--This is the internal name of the mod.
local XBARMOD="XRogueBar";
local dbver="1";

--Default settings and other info about the mod
XBarModData[XBARMOD]={
	----REQUIRED VALUES----
	["nbuttons"]=23,
	["dbver"]=dbver,
	["dhorizontal"]=true,
	["dhidebar"]=false,
	["dorder"]="az",
	["dscale"]=1,
	["dtooltips"]=true,
	["booktype"]=BOOKTYPE_SPELL,
	["enabled"]=true,
	["nchecks"]=20,
	["mchecks"]=false,
	["nsliders"]=0,
	["msliders"]=false,
	["ftexint"]=nil,
	["foptioncb"]=XBARMOD.."_OptionCB",
	["fbuttoncb"]=nil,
	["fbuttonid"]=XBARMOD.."_ButtonID",
};

function XRogueBar_OnLoad()
	local Class,i,n,v;

	-- Nonlocalized class check
	_, Class = UnitClass("player");
	if (Class == "ROGUE") then
		--Each bar must catch its own event notifications
		XBarModData[XBARMOD]["enabled"]=true;
		this:RegisterEvent("SPELLS_CHANGED");
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("BAG_UPDATE");
		this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
	end

	n=0;
	for i,v in pairs(XRogueBarSpells) do
		if (v~=" ") then
			n=n+1;
			XBarModData[XBARMOD]["check"..n]=v;
			XBarModData[XBARMOD]["dcheck"..n]=true;
		end
	end
end

function XRogueBar_OnEvent()
	local refreshdb=false;
	
	-- XBar has built in functionality to update its plugins
	if (event == "SPELLS_CHANGED") then
		XBar_Scale(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "SPELL_UPDATE_COOLDOWN" and XBarPlayerName) then
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "BAG_UPDATE" and XBarPlayerName) then
		-- Updating on bag update because of the reagents required campfires.
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "PLAYER_ENTERING_WORLD") then
		-- Let XBar know we're here so it can set up our data
		-- Double check just in case XBar hasn't got this yet.
		XBar_BuildPlayerName();
		XBar_RegisterAddon(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "ACTIONBAR_UPDATE_USABLE") then
		XBar_UpdateCooldowns(XBARMOD);
	end
end

function XRogueBar_ButtonID(id,spellname)
	local newid=id;

	if (not XBarData[XBarOptionSet]["mods"][XBARMOD][spellname]) then
		newid=nil;
	end

	return newid;
end

function XRogueBar_OptionCB(option,value)
	XBar_Update(XBARMOD);
end