--This is the internal name of the mod.
local XBARMOD="XTotemBar";
local dbver="0";

--Default settings and other info about the mod
XBarModData[XBARMOD]={
	----REQUIRED VALUES----
	["nbuttons"]=30,
	["dbver"]=dbver,
	["dhorizontal"]=true,
	["dhidebar"]=false,
	["dorder"]="az",
	["dscale"]=1,
	["dtooltips"]=true,
	["booktype"]=BOOKTYPE_SPELL,
	["enabled"]=false,
	["nchecks"]=1,
	["check1"]="HighlightAuraTotems",
	["dcheck1"]=true,
	["mchecks"]=false,
	["nsliders"]=0,
	["msliders"]=false,
	--sliders will be set up later in the OnLoad procedure.
	["ftexint"]=XBARMOD.."_Texture",
	["foptioncb"]=XBARMOD.."_Option",
	["fbuttoncb"]=nil,
	["fbuttonid"]=nil,
};

function XTotemBar_OnLoad()
	--Each bar must catch its own event notifications
	local Class;

	-- Nonlocalized class check
	_, Class = UnitClass("player");
	if (Class == "SHAMAN") then
		-- For this mod, only hunters have these spells, so only enable if needed
		XBarModData[XBARMOD]["enabled"]=true;
		this:RegisterEvent("SPELLS_CHANGED");
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
		this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
	end
end

function XTotemBar_OnEvent()
	local refreshdb=false;

	-- XBar has built in functionality to update its plugins
	if (event == "SPELLS_CHANGED") then
		XBar_Scale(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "SPELL_UPDATE_COOLDOWN" and XBarPlayerName) then
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "PLAYER_AURAS_CHANGED") then
		XBar_Update(XBARMOD);
	elseif (event == "PLAYER_ENTERING_WORLD") then
		-- Let XBar know we're here so it can set up our data
		-- Double check just in case XBar hasn't got this yet.
		XBar_BuildPlayerName();
		XBar_RegisterAddon(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "ACTIONBAR_UPDATE_USABLE") then
		XBar_UpdateCooldowns(XBARMOD);
	end
end

function XTotemBar_Texture(texture,spellname)
	local t = texture;
	local b,z;

	-- Will highlight the totem the player has out (if it is an aura effect)
	for z = 1, 50 do
		b=UnitBuff("player",z);

		if (b==nil) then
			break;
		elseif (b==strsub(spellname,1,strlen(b))) then
			-- We found the spell, lets see if we need to update it.
			if (XBarData[XBarOptionSet]["mods"][XBARMOD]["HighlightAuraTotems"]) then
				t = "Interface\\Icons\\Spell_Nature_WispSplode";
			end
		end
	end

	return t;
end

function XTotemBar_Option(option,value)
	-- We only have one option, so no need to check to see which one it is
	-- The value is unimportant as well, as we do the same action either way
	XBar_UpdateCooldowns(XBARMOD);
end
