--This is the internal name of the mod.
local XBARMOD="XTradeBar";
local dbver="2";

local specialized=false;
local minors = {1,2,3,5,6,7,8,9,14,15,17,18,19,21,22,23};
local majors = {4,10,16,20,24};

--Default settings and other info about the mod
XBarModData[XBARMOD]={
	----REQUIRED VALUES----
	["nbuttons"]=36,
	["dbver"]=dbver,
	["dhorizontal"]=true,
	["dhidebar"]=false,
	["dorder"]="az",
	["dscale"]=1,
	["dtooltips"]=true,
	["booktype"]=BOOKTYPE_SPELL,
	["enabled"]=true,
	["nchecks"]=36,
	["mchecks"]=false,
	["nsliders"]=0,
	["msliders"]=false,
	["ftexint"]=nil,
	["foptioncb"]=XBARMOD.."_OptionCB",
	["fbuttoncb"]=nil,
	["fbuttonid"]=XBARMOD.."_ButtonID",
};

function XTradeBar_OnLoad()
	--Each bar must catch its own event notifications
	XBarModData[XBARMOD]["enabled"]=true;
	this:RegisterEvent("SPELLS_CHANGED");
	this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");

	for i,v in pairs(XTradeBarSpells) do
		XBarModData[XBARMOD]["check"..i]=v;
		XBarModData[XBARMOD]["dcheck"..i]=true;
	end
end

function XTradeBar_OnEvent()
	local refreshdb=false;
	
	-- XBar has built in functionality to update its plugins
	if (event == "SPELLS_CHANGED") then
		XBar_Scale(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "SPELL_UPDATE_COOLDOWN" and XBarPlayerName) then
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "BAG_UPDATE" and XBarPlayerName) then
		-- Updating on bag update because of the reagents required campfires.
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "PLAYER_ENTERING_WORLD") then
		-- Let XBar know we're here so it can set up our data
		-- Double check just in case XBar hasn't got this yet.
		XBar_BuildPlayerName();
		XBar_RegisterAddon(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "ACTIONBAR_UPDATE_USABLE") then
		XBar_UpdateCooldowns(XBARMOD);
	end
end

function XTradeBar_ButtonID(id,spellname)
	local newid=id;
	local i,v;

	if (not XBarData[XBarOptionSet]["mods"][XBARMOD][spellname]) then
		newid=nil;
	else
		-- Perform checks to see what we have
		for i,v in pairs(minors) do
			if ((spellname==XTradeBarSpells[v]) and (newid~=nil)) then
				-- this is a Minor profession (specialty)
				if (specialized) then
					-- we found something already, don't show this
					-- This is primarily for weaponsmithing, as there are 2 levels of specialization
					newid=false;
				else
					specialized=true;
				end
			end
		end

		for i,v in pairs(majors) do
			if (spellname==XTradeBarSpells[v]) then
				-- this is a Major profession (unspecialized)
				if specialized then
					-- Hide the main one
					specialized=false;
					newid=nil;
				end
			end
		end
	end

	return newid;
end

function XTradeBar_OptionCB(option,value)
	XBar_Update(XBARMOD);
end
